﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using JSNLog.Infrastructure;
using JSNLog.ValueInfos;

namespace JSNLog
{
    // make Constants public, so the web site project can access this info
    public class Constants
    {
        public const string PackageName = "JSNLog";
        public const string ContextItemRequestIdName = "__JSNLog_RequestId";
        public const string HttpHeaderRequestIdName = "JSNLog-RequestId";
        public const string HttpHeaderXForwardedFor = "X-Forwarded-For";
        public const string GlobalMethodCalledAfterJsnlogJsLoaded = "__jsnlog_configure";
        public const string ConfigRootName = "jsnlog";
        public const string RegexBool = "^(true|false)$";
        public const string RegexPositiveInteger = "^[0-9]+$";
        public const string RegexIntegerGreaterZero = "^[1-9][0-9]*$";
        public const string RegexUrl = @"^[ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789\-._~:/?#[\]@!$&'()*+,;=]+$";
        public const char AppenderNameSeparator = ';';
        public const string RootLoggerNameServerSide = "ClientRoot"; // Cannot use empty logger name server side, so use this instead.
        public const string JSNLogInternalErrorLoggerName = "JSNLogInternalError"; // Used when logging internal errors to Common.Logging
        public const int CorsAccessControlMaxAgeInSeconds = 3600; // Note that many browsers enforce their own max age, so you may not get 3600 seconds.

        // The default for the defaultAjaxUrl attribute.
        // It starts with a ~, which must be resolved. Issue is that in most sites, the home page is at
        // http://domain.com
        // in which case you want the default to be /jsnlog.logger.
        //
        // However, the user could put the site in a Virtual Directory that they made into an Application, resulting 
        // in a home page at
        // http://domain.com/virtdir
        // In that case, the default Ajax url has to be /virtdir/jsnlog.logger

        public const string DefaultDefaultAjaxUrl = "~/jsnlog.logger";

        // There is no RegexLevels, because that regex gets generated by a method in LevelUtils

        public const string JsLogObjectName = "JL";
        public const string JsLogObjectClientIpOption = "clientIP";
        public const string JsLogObjectRequestIdOption = "requestId";
        public const string JsAppenderVariablePrefix = "a";
        public const string JsLoggerVariablePrefix = "logger";

        public static readonly Level DefaultAppenderLevel = Level.TRACE;
    }
}
